#define  USE_HY17M28_2M
#include <SFRType.h>
#include <GPIO.h>
#include <CLK.h>
#include <PWR.h>
#include <CMP.h>

#include "HW_Initial.h"
#include "main.h"

extern unsigned char LEDScan;
//==========================
//name:void SysClock_initial(void)
//
//============================
void SysClock_initial(void)
{
#ifdef HAO_16MHZ
  OSCCN2=0B00000111;//HAOM=11=17.51MHZ,ENHAO=1;
  OSCCN0=0B00000111; //HS_CK=OSC_HAO, DHS_CK=HS_CK/1,DMS_CK=DHS_CK/16,CPU_CK=DHS_CK
  OSCCN1=0B10110000;//CCOPT=1;LPCK=OSC_LPO; ADC_CK=DHS_CK/16;DTMB_CK=00;TMB_CK=HS_CK

#endif

#ifdef HAO_8MHZ
  OSCCN2=0B00000101;//HAOM=10=8MHZ,ENHAO=1;
  OSCCN0=0B00000101; //HS_CK=OSC_HAO, DHS_CK=HS_CK/1,DMS_CK=DHS_CK/8,CPU_CK=DHS_CK
  OSCCN1=0B10100000;//CCOPT=1;LPCK=OSC_LPO; ADC_CK=DHS_CK/8;DTMB_CK=00;TMB_CK=HS_CK

#endif

#ifdef HAO_4MHZ
  OSCCN2=0B00000011;//HAOM=01=4MHZ,ENHAO=1;
  OSCCN0=0B00000011; //HS_CK=OSC_HAO, DHS_CK=HS_CK/1,DMS_CK=DHS_CK/4,CPU_CK=DHS_CK
  OSCCN1=0B10010000;//CCOPT=1;LPCK=OSC_LPO; ADC_CK=DHS_CK/4;DTMB_CK=00;TMB_CK=HS_CK

#endif

#ifdef HAO_2MHZ
  OSCCN2=0B00000001;//HAOM=00=2MHZ,ENHAO=1;
  OSCCN0=0B00000001; //HS_CK=OSC_HAO, DHS_CK=HS_CK/1,DMS_CK=DHS_CK/2,CPU_CK=DHS_CK
  OSCCN1=0B10000000;//CCOPT=1;LPCK=OSC_LPO; ADC_CK=DHS_CK/2;DTMB_CK=00;TMB_CK=HS_CK

#endif

}
//==========================
//name:void PowerInitial(void)
//FUNCT: POWER INITIAL
//============================
void PowerInitial(void)
{
  PWRCN=0B10000000; //ENBGR=1;
  PWRCN=0B10000010; //VDDA=2.4V;LDOM=00=HIGH IMPENCE;VDDA LDO=1;CSFON=1;
  Delay(300); //delay time for VDDA

  AD1CN5=0B10011000; //ENVCM=1;VCMS=0=ACMin;LDOPL=1=250K;ENREFO=1;
  AD1CN1=0B00001010;//REFO1=1=REFO OUTPUT; REFO=1.2V;
  AD1CN0=AD1CN0| 0x80; //ENAD1=1;ENABLE ADC for enable the V12 output
}
void GPIO_initial(void)
{
//==pt1 initial==
 TRISC1=TRISC1|0x06;//PT1.2~1 as output
 PT1IN=PT1IN|0x46;//PT1.2~1 enable input
 PT1PU=PT1PU|0x40;//PT1.7~4 pull HIGH
 PT1=PT1|0x06;//pt1.2~1 output high
 //==PT3 initial ==
#ifdef ide
 PT3IN=PT3IN|0xC2;//PT3.1/3.6/3.7 enable input
 PT3PU=PT3PU|0xC2;//PT3.1/3.6/3.7 pull HIGH

 TRISC3=TRISC3|0x01;//PT3.0 as OUTput mode for BZ
 PT3=PT3&0xfe;

// PT3IN=PT3IN|0xC2;//PT3.1/3.2/3.3/3.6/3.7 enable input
// PT3PU=PT3PU|0xC0;//PT3.2/3.3/3.6/3.7 pull HIGH
// TRISC3=TRISC3|0x03;//PT3.0/3.1 as OUTput mode,PT3.0 for BZ
// PT3=0x02; //pt3.1=1,pt3.0=0
#endif
#ifdef IC_BODY
 //TRISC3=TRISC3&0xfd;//PT3.1 as input mode
 PT3IN=PT3IN|0xCe;//PT3.1/3.2/3.3/3.6/3.7 enable input
 PT3PU=PT3PU|0xCc;//PT3.2/3.3/3.6/3.7 pull HIGH

 TRISC3=TRISC3|0x03;//PT3.0/3.1 as OUTput mode,PT3.0 for BZ
 PT3=0x02; //pt3.1=1,pt3.0=0
#endif
}

//=============================================
//Buzzer initial
//=============================================
void Buzzer_initial(void)
{
 //=BZ initial ==
 WDTCN=0B01010000; //SET ENBZ=0;BZ_CK=LS_CK;BZ[1:0]=01
 GPORT0=0B01100000; //SET PT3.0 AS BZ output pin
}

void Buzzer_ON(void)
{
  WDTCN=WDTCN| 0x80; //SET ENBZ=1;
}
void Buzzer_OFF(void)
{
  WDTCN=WDTCN& 0x7f; //SET ENBZ=0;
  PT3=PT3&0xfe;
}
//------------------------------------------------------------
//name:LED_initial(void)
//FUNCT:INITIAL LED DRIVER
//------------------------------------------------------------
void LED_initial(void)
{
  //CCNT=0x07;       //15mA
  //CCNT=0x03;         //7mA
  CCNT=0x02;       //5mA
  //CCNT=0x01;       //3mA
  ENCCMODE=0xff;
  PT2DA=0x00;
  INTE0 |= 0x40;
  TMA1CN=0xc0;
  TMA1C=2;		    //Set Scan Rate
//==SET LED SCAN FRE==
  //LEDScan=1;
  LEDScan=2;

}
//====================================
//name; ADC_initial(void)
//FUNCT: ADC INITIAL
//=====================================
void ADC_initial(void)
{
  PT3DA=PT3DA| 0x10;//PT3.4 AS ANLOG PIN
  AD1CN1=0B00101010; //REFO1=REFO OUTPUT; ADGAIN=010=1;
  AD1CN5=0B10011000; //ENVCM=1;V12SEL=0=REFO;VCMS=0=ACMin;LDOPL=1=250K;ENREFO=1;
  MCCN1=MCCN1&0xbf;//VRSEL=0=ACMIN//| 0x40;//VRSEL=1=REFOIN

  AD1CN0=0B10000110; //ENAD1=1; OSR=0011=8192; CMFR=0;
  AD1CN2=0B00000000; //SELVIN=0=VDDA/2
  AD1CN3=0B01110111; //INP=RAINP, INN=RAINN;FOR '100K'
  AD1CN4=0B11000000; //VRH=11=V12SEL; VRL=00=VSS;INX=00;VRIS=0;INIS=0;




  //AD1CN0=AD1CN0| 0x80; //ENAD1=1;ENABLE ADC

  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF


  //====LNOP SETUP ===

  LNAMP0=0B00000100;//INN[4]=INP[4]=0;TR2Chop=1=AI3 short V12;TR1Chop=1=AI0 short V12;
  LNAMP1=0B10000100;//OP GAIN=20
}
void RS_initial(void)
{
 // MCCN1=MCCN1&0xbf;//VRSEL=0=ACMIN//| 0x40;//VRSEL=1=REFOIN

  AD1CN1=0B00101010;//VRGN=1,REFO=10=1.2.0V//0B00000010; //REFO1=REFO OUTPUT; ADGAIN=010=1;
  AD1CN2=0B11000000; //ADC BUFFER ENABLE,SELVIN=0=ACMin=VDDA/2
  AD1CN4=0B00000000;//VRF=VDDA-VSS//0B11000000; //VRH=11=V12SEL; VRL=00=VSS;INX=00;VRIS=0;INIS=0;
  AD1CN5=AD1CN5& 0xbf; //V12SEL=0=REFO
  AD1CN0=0B10000100; //ENAD1=0; OSR=0010=16384; CMFR=0;

  LNAMP0=0B00000100;//INN[4]=INP[4]=0;TR2Chop=1=AI3 short V12;TR1Chop=1=AI0 short V12;
  LNAMP1=0B10000100;//OP GAIN=20
  //LNAMP1=0B00000000;//ENPGA=0,DISBLE PGA;OP GAIN=20
  __asm__("nop");
  __asm__("nop");
  __asm__("nop");
  __asm__("nop");

}
//=====================================
//name: RF_initial()
//function: measure 'RF' , ADC VIN= Rinp--Rinn; VREF=REFOI-VSS
//=====================================
void RF_Positive(void)
{
  AD1CN2=0B11000000; //ADSIPB=1=BUFFER,ADSINB=1,SELVIN=0=VDDA/2
  AD1CN3=0B01110111; //INP=RAINP, INN=RAINN;FOR '100K'
  //AD1CN4=0B11000000; //VRH=11=V12SEL; VRL=00=VSS;INX=00;VRIS=0;INIS=0;
  //AD1CN5=AD1CN5& 0xbf; //V12SEL=0=REFO



  AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}

void RF_intersect(void)
{
  AD1CN3=0B10000110; //INN=RAINP, INP=RAINN;FOR '100K'

  AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}

//=====================================
//
//function: measure 'RF' , ADC VIN=AI7 -VSS; VREF=REFOI-VSS
//=====================================
void TS_Positive(void)
{
	AD1CN2=0B10000000; //ADSIPB=1=BUFFER,ADSINB=0,SELVIN=0=VDDA/2

   AD1CN3=0B01011111; //INP=AI7, INN=VSS;FOR 'TS'
   AD1CN4=0B00000000;//VRF=VDDA-VSS//0B11000000; //VRH=11=V12SEL; VRL=00=VSS;INX=00;VRIS=0;INIS=0;
  //AD1CN5=AD1CN5& 0xbf; //V12SEL=0=REFO


   AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}
void TS_intersect(void)
{
	AD1CN2=0B01000000; //ADSIPB=0,ADSINB=1=BUFFER,SELVIN=0=VDDA/2
	AD1CN4=0B00001100;//VRF=VDDA-VSS//0B11001100; //VRH=11=V12SEL; VRL=00=VSS;INX=11;VRIS=0;INIS=0;

  AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}
//=====================================
//
//
//=====================================
void TP_initial(void)
{
 MCCN1=MCCN1&0xbf;//VRSEL=0=ACMIN
 //MCCN1=MCCN1|0x40;//VRSEL=1=REFOIN
 AD1CN1=0B00101101;//VRGN=*1/2,ADGN=*8//0B00000101;//VRGN=*1,ADGN=*8,//
 AD1CN2=0B00000000;//SELVIN=0,ACMC=VDDA/2//0B00010000;//SELVIN=1,ACMC=V12//
 AD1CN3=0B10101000;
 AD1CN4=0B00000000;//VREF=VDDA-VSS //0B11000000;//VREF=V12--VSS//
 AD1CN5=0B11011000;//ENVCM=1,V12SEL=1=V12,VCMS=0,LDOPL=1,ENREFO=1//0B10011000;//
 AD1CN0=0B10000101;//ENAD1=1,OSR=0010=16384=61hz

 //LNAMP0=0B00000100; //OP INPUT:TP=AI0--V12
 //LNAMP1=0B10000100; //OP GAIN=*20 OP Chopper= positive
 //__asm__("nop");
 //__asm__("nop");
}
void TP_Positive(void)
{
	LNAMP0=0B00000100; //TP=AI0--V12
//	LNAMP1=0B10000100;

  AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}

void TP_intersect(void)
{
	LNAMP0=0B00001100;//TP=V12--V12

  AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
  AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
  INTF0=INTF0& 0xdf; //clear ADCIF
}
