#define  USE_HY17M28_2M
#include <SFRType.h>

#include "HW_Initial.h"
#include "app_task.h"
#include "main.h"
#include "IR_Table.h"
//------------------------------------------
extern unsigned char work_flag;
extern long signed ADC_TEMP;
extern long signed int ADC_BUF;
extern unsigned char adc_mode;
extern unsigned char counter;
extern unsigned char drop_out;

extern long signed int RF_ADC;
extern long signed int RS_ADC;
extern long signed int TP_ADC;

extern long unsigned int TP_GAIN;
extern long unsigned int TS_GAIN;

extern unsigned int TVS_VALUE;
extern unsigned int TS_TEMPER;
extern long unsigned int TP_TEMPER;

extern unsigned char index;
extern unsigned char remain;

extern long signed int adc_max;
extern long signed int adc_min;
extern unsigned char REG[12]; //temperature compensation
//extern unsigned long int T1,T2;
//---------------------------------------
//Name: Get_adc()
//FUN: measure all chenal and get adc data
//---------------------------------------
void Get_adc(void)
{
 if(work_flag&adc_int_flag)
 {
   work_flag=(~adc_int_flag)&work_flag; //clear flag;
   INTE0=INTE0&0xdf; //diasble ADC interrupt
   INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG

   switch(adc_mode)
   {
     case 0://measure RF_positive
     {
    	RF_ADC=ADC_TEMP>>6;//8; //drop low 8bit data
  		if((work_flag&adc_chopper)==0)
  		{
  			counter= 2;//4;
  		    ADC_BUF= 0;
  			work_flag=work_flag|adc_chopper;//adc_chopper=1,enable adc chopper

  		}
  		adc_mode= 1;
  		drop_out=0;
  	    RF_intersect();//change to measure RF_Negative

        //AD1CN0=AD1CN0| 0x01;//reset CMFR
        work_flag=(~adc_int_flag)&work_flag; //clear flag;
  		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0|0x20;//enable adc interrupt

       break;
     }
     case 1: //measure RF_NEGATIVE
     {
    	ADC_TEMP=ADC_TEMP>>6;//8; //drop low 8bit data
        RF_ADC=(RF_ADC - ADC_TEMP)>>1; //take out the ADC OFFSET

  		ADC_BUF=ADC_BUF+RF_ADC;//for average
  		counter=counter-1;
  		if(counter==0)
  		{
  		 RF_ADC=ADC_BUF>>1;//2;
  		 work_flag=work_flag&(~adc_chopper);//adc_chopper=0
  		 adc_mode= 2;
  		 drop_out=0;
  		 //--initial the TS --
  		 TS_Positive();
  		}
  		else
  		{
  		 adc_mode= 0;
  		 drop_out=0;
  		 RF_Positive();//change to measure RF_positive
  		}

  		//AD1CN0=AD1CN0| 0x01;//reset CMFR
  		work_flag=(~adc_int_flag)&work_flag; //clear flag;
   		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0| 0x20;//enable adc interrupt

       break;
     }
     case 2://TS_Positive
     {
        RS_ADC=(ADC_TEMP);
        RS_ADC=(RS_ADC>>6);
    	//RS_ADC=(ADC_TEMP>>6);//8; //drop low 8bit data
  		if((work_flag&adc_chopper)==0)
  		{
  			counter= 2;//4;
  		    ADC_BUF= 0;
  			work_flag=work_flag|adc_chopper; //adc_chopper=1 enable the adc chopper

  		}
  		adc_mode= 3;
  		drop_out= 0;
  	    TS_intersect();//change to measure TS_Nagetive

        //AD1CN0=AD1CN0| 0x01;//reset CMFR
        work_flag=(~adc_int_flag)&work_flag; //clear flag;
  		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0| 0x20;//enable adc interrupt

       break;
     }
     case 3://MEASURE TS_Negative
     {
    	ADC_TEMP=ADC_TEMP>>6;//8; //drop low 8bit data
        RS_ADC=(RS_ADC - ADC_TEMP)>>1;//take out the ADC OFFSET

  		ADC_BUF=ADC_BUF+RS_ADC;//for average
  		counter=counter-1;
  		if(counter==0)
  		{
  		 RS_ADC=ADC_BUF>>1;//2;//GET TS ADC

  		 work_flag=(~adc_chopper)&work_flag;//adc_chopper=0
  		 adc_mode= 4;
  		 //--initial the TP --
  		 drop_out=0;
          TP_initial();
          TP_Positive();
  		}
  		else
  		{
  		 adc_mode= 2;
  		 drop_out= 0;
  		 TS_Positive();//change to measure TS_positive
  		}

  		//AD1CN0=AD1CN0| 0x01;//reset CMFR
  		work_flag=(~adc_int_flag)&work_flag; //clear flag;
   		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0| 0x20;//enable adc interrupt

       break;
     }
     case 4://measure TP_Positive
     {
    	TP_ADC=ADC_TEMP>>TP_length;//8; //drop low 8bit data
  		if((work_flag&adc_chopper)==0)
  		{
  			counter= 6;//4;
  		    ADC_BUF= 0;
  			work_flag=work_flag | adc_chopper;//adc_chopper=1,enable the adc chopper

  		}
  		adc_mode= 5;
  		drop_out=0;
  	    TP_intersect();//change to measure TP_zero

        //AD1CN0=AD1CN0| 0x01;//reset CMFR
        work_flag=(~adc_int_flag)&work_flag; //clear flag;
  		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0| 0x20;//enable adc interrupt

       break;
     }
     case 5:
     {
    	ADC_TEMP=ADC_TEMP>>TP_length;//8; //drop low 8bit data
        TP_ADC=(TP_ADC - ADC_TEMP)>>1;//take out the ADC OFFSET

  		ADC_BUF=ADC_BUF+TP_ADC;//for average
//================================
  if(counter==6)
  {
   adc_max=TP_ADC;
   adc_min=TP_ADC;
  }
  else
  {
    if(adc_max>TP_ADC)//TP_ADC < adc_max
    {
      if(TP_ADC<adc_min)//TP_ADC< adc_min
      {
        adc_min=TP_ADC;
      }
    }
    else//TP_ADC >= adc_max
    {
     adc_max=TP_ADC;
    }
  }//*/
  		counter=counter-1;
  		if(counter==0)
  		{
  		 ADC_BUF=ADC_BUF-adc_max-adc_min;//drop out the max and the min adc data

  		 TP_ADC=ADC_BUF>>2;//GET TP ADC

  		 work_flag=work_flag&(~adc_chopper);//adc_chopper=0;
  		 adc_mode= 0;

  		 work_flag=work_flag|adc_ok_flag; //finish adc measure;
  		 //--initial the RF ---
 	     RS_initial();
 	     drop_out=0;
         RF_Positive();
  		}
  		else
  		{
  		 adc_mode= 4;
  		 drop_out=0;
  		 TP_Positive();//change to measure TP_positive
  		}
  		//AD1CN0=AD1CN0| 0x01;//reset CMFR
  		work_flag=(~adc_int_flag)&work_flag; //clear flag;
   		INTF0=INTF0& 0xdf;//clear adcif
  		INTE0=INTE0| 0x20;//enable adc interrupt

       break;
     }
     default:
       break;
   }

 }
}
//===============================
void RF_MEASURE(void)
{
 //--initial the RF ---
   counter=4;
   ADC_BUF=0;
   RS_initial();
  while(counter>0)
  {
   RF_Positive();
   work_flag=(~adc_int_flag)&work_flag; //clear flag;
   INTF0=INTF0& 0xdf;//clear adcif
   INTE0=INTE0|0x20;//enable adc interrupt
   while(!(work_flag&adc_int_flag));
   INTE0=INTE0&0xdf; //diasble ADC interrupt
   INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
   work_flag=(~adc_int_flag)&work_flag; //clear flag;

   RF_ADC=ADC_TEMP>>6; //drop low 8bit data

   RF_intersect();//change to measure RF_Negative
   work_flag=(~adc_int_flag)&work_flag; //clear flag;
   INTF0=INTF0& 0xdf;//clear adcif
   INTE0=INTE0|0x20;//enable adc interrupt
   while(!(work_flag&adc_int_flag));
   INTE0=INTE0&0xdf; //diasble ADC interrupt
   INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
   work_flag=(~adc_int_flag)&work_flag; //clear flag;

   ADC_TEMP=ADC_TEMP>>6; //drop low 8bit data
   RF_ADC=(RF_ADC - ADC_TEMP)>>1; //take out the ADC OFFSET

   ADC_BUF=ADC_BUF+RF_ADC;//for average
   counter=counter-1;
  }
  RF_ADC=ADC_BUF>>2;
}
//=============================
void TS_MEASURE(void)
{
  counter=4;
  ADC_BUF=0;
  while(counter>0)
  {
   TS_Positive();
   work_flag=(~adc_int_flag)&work_flag; //clear flag;
   INTF0=INTF0& 0xdf;//clear adcif
   INTE0=INTE0|0x20;//enable adc interrupt
   while(!(work_flag&adc_int_flag));
   INTE0=INTE0&0xdf; //diasble ADC interrupt
   INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
   work_flag=(~adc_int_flag)&work_flag; //clear flag;

   RS_ADC=ADC_TEMP>>6;//8; //drop low 8bit data

   TS_intersect();//change to measure TS_Nagetive
   work_flag=(~adc_int_flag)&work_flag; //clear flag;
   INTF0=INTF0& 0xdf;//clear adcif
   INTE0=INTE0|0x20;//enable adc interrupt
   while(!(work_flag&adc_int_flag));
   INTE0=INTE0&0xdf; //diasble ADC interrupt
   INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
   work_flag=(~adc_int_flag)&work_flag; //clear flag;

   ADC_TEMP=ADC_TEMP>>6;//8; //drop low 8bit data
   RS_ADC=(RS_ADC - ADC_TEMP)>>1;//take out the ADC OFFSET

   ADC_BUF=ADC_BUF+RS_ADC;//for average
   counter=counter-1;
  }
  RS_ADC=ADC_BUF>>2;
}
//=============================
void TP_MEASURE(void)
{
//--initial the TP --
  counter=4;
  ADC_BUF=0;
  TP_initial();
  while(counter>0)
 {
  TP_Positive();
  work_flag=(~adc_int_flag)&work_flag; //clear flag;
  INTF0=INTF0& 0xdf;//clear adcif
  INTE0=INTE0|0x20;//enable adc interrupt
  while(!(work_flag&adc_int_flag));
  INTE0=INTE0&0xdf; //diasble ADC interrupt
  INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
  work_flag=(~adc_int_flag)&work_flag; //clear flag;

  TP_ADC=ADC_TEMP>>8; //drop low 8bit data

  TP_intersect();//change to measure TP_zero
  work_flag=(~adc_int_flag)&work_flag; //clear flag;
  INTF0=INTF0& 0xdf;//clear adcif
  INTE0=INTE0|0x20;//enable adc interrupt
  while(!(work_flag&adc_int_flag));
  INTE0=INTE0&0xdf; //diasble ADC interrupt
  INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
  work_flag=(~adc_int_flag)&work_flag; //clear flag;

  ADC_TEMP=ADC_TEMP>>8; //drop low 8bit data
  TP_ADC=(TP_ADC - ADC_TEMP)>>1;//take out the ADC OFFSET

  ADC_BUF=ADC_BUF+TP_ADC;//for average
  counter=counter-1;
 }
 TP_ADC=ADC_BUF>>2;
//*/
}
/******** caculate the TS temperature ******
;-----------------------------------
;RS = GAIN1 * RS_ADX / RF_ADX
;-----------------------------------*/
void TS_TEMPERATURE(void)
{

	//unsigned char index=0;
	//unsigned char remain=0;

	unsigned int T1=0;
	unsigned int T2=0;

	ADC_BUF= TS_GAIN*RS_ADC;
	//ADC_BUF=(ADC_BUF)/RF_ADC;  //
	ADC_BUF=(ADC_BUF+(RF_ADC>> 2))/RF_ADC;  //;õThermistorֵ:RS = GAIN1 * RS_ADX / RF_ADX
																					//RF_ADC>>2 for round up and round down numbers

//;INDEX=5700H-RS_H|RS_L=22272-RS_H|RS_L
	//ADC_BUF= 0x5700 - ADC_BUF;
    ADC_BUF=R2T_HEADER - ADC_BUF;

	remain=ADC_BUF& 0xff;
	ADC_BUF=ADC_BUF>> 8;
	index=ADC_BUF& 0xff;
//;--------------------------------------------------------------
//;FIND TABLE:T1+(T2-T1)*DIFFERENCE/256
//;---------------------------------------------------------------
	T1=R2T[index];
	T2=R2T[index+1];

	T2=(T2-T1)*remain;
	T2=(T2+64)/256;//64=256/4,for round up and round down numbers
	TS_TEMPER=T1+T2; //;õThermopilehضTS:T1+(T2-T1)*DIFFERENCE/256
	ADC_BUF= 0;
}

//=======================================
//=TEMPERATURE TO VOLTAGE
//=OUTPUT: TVS_VALUE
//========================================
void TSV_VOLTAGE(void)
{
	//unsigned char remain=0;
	//unsigned char index=0;

	unsigned int v1=0;
	unsigned int v2=0;
	//;---------- INDEX=(TS - 256)/64 ------------
	ADC_BUF=TS_TEMPER-256;
	remain=ADC_BUF& 0x3f;
	index=ADC_BUF>> 6;

		if(index<=T2V_Length) //CHECK LENGTH ,0TP-638D2 Table
		{
//;-------------------------------------------
//;FIND TABLE: V1+(V2-V1)*DIFFERENCE/64
//;-------------------------------------------
			v1=T2V[index];
			v2=T2V[index+1];
			v2=(v2-v1)*remain;
			v2=(v2+16)>>6; //16=64/4,for round up and round down numbers
			TVS_VALUE=v1+v2; //;õ Vout ( Ta, 0?

		}
		else
		{
	 		work_flag=work_flag|temper_high;//temperature high than table.
		}
   ADC_BUF= 0;

}

void DEAL(void)
{
	//unsigned char remain=0;
	//unsigned int   index=0;

	unsigned long int T1,T2;

	INTF0=INTF0&0xdf;  //clear the ADC IF	    ;BCF		INTF1,ADCIF,A
	INTE0=INTE0&0xdf; //disable the ADC INT  ;BCF		INTE1,ADCIE,A

	TS_TEMPERATURE();  //ӋThermopilehض
	TSV_VOLTAGE();  //ӋThermopileݔ늉
/*;----------------------------------------------------------
;TSV_VALUE+/- (TP_GAIN * TP_ADX )/100H
;------------------------------------------------------------*/
	ADC_BUF=TP_ADC;
	if(TP_ADC<0)
	{
		ADC_BUF=(~ADC_BUF)+1;
	}
//;------- TP_GAIN * TP_ADX/100H ---------
	ADC_BUF=ADC_BUF*TP_GAIN/10;
	//ADC_BUF=ADC_BUF/ 0x100;//
	ADC_BUF=(ADC_BUF+ 0x40)/ 0x100;//0X40=0X100/4 ,For round up and round down numbers
//;----- TSV_H|TSV_L +(-) TP_GAIN * TP_ADX/100 -----
	if(TP_ADC<0)
	{
		ADC_BUF=TVS_VALUE - ADC_BUF;
	}
	else
	{
		ADC_BUF=TVS_VALUE +ADC_BUF;
	}
	//TP_TEMPER=ADC_BUF;
//***CHECK 'V2T TABLE *******

	remain=ADC_BUF& 0x003f; //TP_TEMPER% 64
	index=ADC_BUF>>6;////TP_TEMPER / 64
	if(index>V2T_Length)  //over the 'V2T' table
	{
	  work_flag=work_flag|temper_high;//temperature high than table.
	  ADC_BUF=0;
		//goto SHOW_T;
	}
	else
	{
 //;----- T1+(T2-T1)*DIFFERENCE/64 -----
		T1=V2T[index];  //GET THE 1 'TP TEMPERETURE'
		T2=V2T[index+1];//GET THE 2'TP TEMPERETURE'

		T2=(T2-T1);
		T2=(T2*remain+16)>>6;  //(T2*remain)>>6;  //(T2-T1)*DIFFERENCE/64 ;//16=64/4,for round up and round down numbers
		TP_TEMPER=(T1+T2)/100;  //T1+(T2-T1)*DIFFERENCE/64

		ADC_BUF=0;
	}

	if((PT3&0x8)==0)   //;ДPT3.3_λ
	{
		COMPENSATE();  //;~؜ضa
	}//*/


	work_flag=work_flag|ADC_finish;//finish measure and caculate


	AD1CN0=AD1CN0|0x01;//reset CMFR
	INTF0=INTF0&0xdf;  //clear the ADC IF
	INTE0=INTE0|0x20;  //enable the ADC INT
	INTF0=INTF0&0xdf;  //clear the ADC IF

}

//============================================================
//Function:temperature compensation
//=============================================================
void COMPENSATE(void)
{
	if(REG[11]==0x5A)//;ДEEPROMǷЌضaֵ,;EEPROMЛ]ЌضaֵʹPT1.7=highҲa
	{
		if((TP_TEMPER>=0xc80)&&(TP_TEMPER<0x10cc))//Дضȹ:C80H3200D<TP_TEMPER <10CC4300D
		{
			if(TP_TEMPER<3300) //
			{
				TP_TEMPER=TP_TEMPER+REG[0];
			}
			else if(TP_TEMPER<3400)
			{
				TP_TEMPER=TP_TEMPER+REG[1];
			}
			else if(TP_TEMPER<3500)
			{
				TP_TEMPER=TP_TEMPER+REG[2];
			}
			else if(TP_TEMPER<3600)
			{
				TP_TEMPER=TP_TEMPER+REG[3];
			}
			else if(TP_TEMPER<3700)
			{
				TP_TEMPER=TP_TEMPER+REG[4];
			}
			else if(TP_TEMPER<3800)
			{
				TP_TEMPER=TP_TEMPER+REG[5];
			}
			else if(TP_TEMPER<3900)
			{
				TP_TEMPER=TP_TEMPER+REG[6];
			}
			else if(TP_TEMPER<4000)
			{
				TP_TEMPER=TP_TEMPER+REG[7];
			}
			else if(TP_TEMPER<4100)
			{
				TP_TEMPER=TP_TEMPER+REG[8];
			}
			else if(TP_TEMPER<4200)
			{
				TP_TEMPER=TP_TEMPER+REG[9];
			}
			else
			{
				TP_TEMPER=TP_TEMPER+REG[10];
			}
		}

	}

}
