#define  USE_HY17M28_2M
//===================================
//File: HY17M28_IR
//HAO=2MHZ
//TS:AI7--VSS,VREF=VDDA-VSS/2;REFO=2.0V
//TP:AI0--V12,VREF=VDDA-VSS/2;REFO=2.0V
//Note: PT3.2: CAL ,PT3.1/PT1.1/PT1.2 as LED; PT3.6 AS'SCAN',PT3.7 AS'POWER ON/OFF'
//LED display show on/off when measure TP/TS
//===================================
#include <SFRType.h>
#include <GPIO.h>
#include <CLK.h>
#include <PWR.h>
#include <CMP.h>
#include <UART.h>
#include <BIE.h>
#include <PWR.h>
#include <RST.h>
#include "main.h"
#include "HW_Initial.h"
#include "app_task.h"
#include "Display.h"

//#include "LED_TABLE.h"
#define LED_SHOW //enable LED funtion program

//==set enable UART function PT1.3/PT1.4 PIN==
//#define UART_EN  //enable UART initial program
//#define UART_ABD //auto Buad Rate funciton
//---------------------------------------------------------
unsigned char KEYWORK_FLAG=0; //key flag
unsigned char REST=0;

unsigned char key_flag=0;
unsigned int  keystate=0xffff;
unsigned char sys_mode=0;//1:normal mode; 0:system initial
unsigned char work_flag=0;

long signed int ADC_TEMP=0; //ADC DATA BUFFER
unsigned char adc_mode=0;
long signed int ADC_BUF=0;
unsigned char counter=0;
unsigned char drop_out=0;

long signed int RF_ADC=0;
long signed int RS_ADC=0;
long signed int TP_ADC=0;
long unsigned int TP_GAIN=0;
     unsigned char TP_5A=0;
long unsigned int TS_GAIN=0;
     unsigned char TS_5A=0;
long signed int CAL_ADC_BUF=0;
unsigned int TVS_VALUE=0;
unsigned int TS_TEMPER=0;
long unsigned int TP_TEMPER=0;
long unsigned int DATA_BUF=0;

long signed int adc_max=0;
long signed int adc_min=0;

unsigned char index=0;
unsigned char remain=0;
unsigned char HOLDMODE=0;

unsigned char LED[8];
unsigned char LEDScan;
long signed  ADCData1;

unsigned char REG[12]={0}; //temperature compensation
//unsigned long int T1,T2;
unsigned char flash_count=0;// for LED flash show control
unsigned int Time_out=0;
#define  Uart_TX_BufferSize 11//10
unsigned char UartTxBuffer[Uart_TX_BufferSize]={0x77,0x77,0x77,0x8,0,0,0,0,0,0,0};
//=========================================================
void UARTInit(void);
void UART_ADC(void);

//--------------------------------------------------------
void main(void)
{

 SysClock_initial();
 PowerInitial();

 SYS_Parameter_Read();//READ Calibration parameter
 ADC_initial();
 GPIO_initial();
 Buzzer_initial();
#ifdef LED_SHOW
 LED_initial();
#endif
 INTE0=INTE0|0x80;//enable GIE
 Buzzer_ON();
 Delay(7000); //24*7ms
 Buzzer_OFF();
 HYCON_show();
 //=lighte on red/green/blue led =
#ifdef ide
 //PT3=PT3&0xfd;//pt3.1=0;
 PT1=PT1&0xf7;//pt1.3=0
 Delay(3000); //72ms
 PT1=PT1|0x08;//pt1.3=1
 PT1=PT1&0xfD;//pt1.1=0
 Delay(3000);
 PT1=PT1|0x02;//pt1.1=1
 PT1=PT1&0xfB;//pt1.2=0
 Delay(3000);
#endif
#ifdef IC_BODY
 PT1=PT1|0x06;//pt1.1/1.2=1
 PT3=PT3&0xfd;//pt3.1=0 red led
 Delay(7000); //24*7ms
 PT3=PT3|0x02;//pt3.1=1
 PT1=PT1&0xfD;//pt1.1=0 green led
 Delay(7000);
 PT1=PT1|0x02;//pt1.1=1
 PT1=PT1&0xfB;//pt1.2=0 yellow led
 Delay(7000);
#endif

//==== calibration mode =====
 if((PT_CAL&CAL_PIN)==0)//CALIBRATION MODE
 {
  Delay(1000);//24MS
  if((PT_CAL&CAL_PIN)==0)
  {
   show_cal(); //get into calibrate mode,then to calibrate 'TS' OR 'TP'
   Delay(50000);//1200ms
   //Delay(50000);//1200ms
   if(PT_CAL&CAL_PIN)//'TS' calibrate mode
   {
    SHOWCAL1(); //show the 'CAL1 'MODE
    Delay(20000);//24*20ms  
    work_flag=work_flag|ADC_NO_CAL;//enable the 'no calibrate' flag;  
    error_show();//20221130
    HOLDMODE=calibrate_count;//0x4;//
    work_flag=work_flag|cal_ok;    
    
    
    RS_initial();
    RF_Positive();
    work_flag=(~adc_int_flag)&work_flag; //clear flag;
    INTE0=INTE0|0x20;//enable adc interrupt
    while(work_flag&cal_ok)
    {
//--initial the RF ---
      while((work_flag&adc_ok_flag)==0)
      {
        Get_adc();//measure and get adc
      }

      INTE0=INTE0&0xdf; //diasble ADC interrupt
      INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
      work_flag=work_flag&(~adc_ok_flag);
      if(HOLDMODE>0)
      {
		if(RS_ADC< CAL_ADC_BUF)
		  ADC_BUF=CAL_ADC_BUF- RS_ADC;
		else
		  ADC_BUF=RS_ADC- CAL_ADC_BUF ;
		if(ADC_BUF <3)//4)//2)//
		{
		 CAL_ADC_BUF=(CAL_ADC_BUF+RS_ADC)>>1;
		 HOLDMODE--;
		 //LED_Display_show(RS_ADC);
		 if(HOLDMODE==0)
		 {
//;-----------------------------------------------------
//;GAIN1 = 1F40H * RF_ADX / RS_ADX
//;------------------------------------------------------
		   RS_ADC=CAL_ADC_BUF;
		   TS_GAIN=0x1f40;
		   TS_GAIN=TS_GAIN*RF_ADC;
		   //TS_GAIN=(TS_GAIN)/RS_ADC;//
		   TS_GAIN=(TS_GAIN+(RS_ADC>>2))/RS_ADC;//RS_ADC>>2,for round up and round down numbers
		   TS_5A=0x5a;

           work_flag=work_flag&(~cal_ok);

		 }

		}
		else
		{
		 CAL_ADC_BUF=RS_ADC;
		 HOLDMODE=calibrate_count;//0x4;//0x32;//
		}

       AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
       AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
       work_flag=(~adc_int_flag)&work_flag; //clear flag;
       INTF0=INTF0& 0xdf; //clear ADCIF
       INTE0=INTE0| 0x20;//enable adc interrupt
      }

     }
     work_flag=work_flag|cal_ok;
     work_flag=work_flag&(~ADC_T);
//--initial the RF ---
     RS_initial();
     RF_Positive();
     work_flag=(~adc_int_flag)&work_flag; //clear flag;
     INTE0=INTE0|0x20;//enable adc interrupt
     while(work_flag&cal_ok)
     {
      Get_adc();//measure and get adc
      if(work_flag&adc_ok_flag)
      {
       INTE0=INTE0&0xdf; //diasble ADC interrupt
       INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
       work_flag=work_flag&(~adc_ok_flag);
       if(work_flag&ADC_T)
       {
         //==show 'TS' ADC CODE
         LED_Display_show(RS_ADC);

          PT3INTE=PT3INTE| 0x40; //enable the PT3.6 interrupt

       }
       else
       {
         //==caculate the TS temperature
         TS_TEMPERATURE();

         //==show the temperature value
         LED_Display_show(TS_TEMPER);

         PT3INTE=PT3INTE| 0x40; //enable the 3.6 interrupt

       }

       AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
       AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
       work_flag=(~adc_int_flag)&work_flag; //clear flag;
       INTF0=INTF0& 0xdf; //clear ADCIF
       INTE0=INTE0|0x20;//enable adc interrupt

      }
      if((PT3&KEY_POWER)==0)
      {
       Delay(3000);//24*3MS
       if((PT3&KEY_POWER)==0)
       {
         //==close LED show ==
         TMA1CN=TMA1CN&0x7f;
         ENCCMODE=0x00;
         PT2=0;
        Delay(10000);//24MS
        while(!(PT3&KEY_POWER));
        Delay(5000);//24*5MS
        work_flag=work_flag&(~cal_ok);
        PT3INTE=PT3INTE& 0xBf; //close PT3.6 interrupt
        INTE0=INTE0&0x7f;//disable GIE
        //==save the calibrate value to eeprom
        BIE_EEPMode(EEMODE_32bytes);  //Select EEPROM mode
        FSR0=&EERD0;
        CLEAR_EEPROM(4);//CLEAR THE EEPROM Buffer register,not BIE
        //CLEAR_EEPROM(0x0,4);//EERDCLR(32);  //Clear EERD0~63 //
        //--EERD0~EERD3 ---
        FSR0=&EERD0;
        DATA_BUF=TS_GAIN;
        POINC0=TS_5A;//EERD0
        POINC0=DATA_BUF&0xff;
        DATA_BUF=DATA_BUF>>8;
        POINC0=DATA_BUF&0xff;
        DATA_BUF=DATA_BUF>>8;
        POINC0=DATA_BUF&0xff;

        BIE_DataWrite();  //Write EERD to BIE,data write to BIE
        //INTE0=INTE0|0x80;//enable GIE
        work_flag=work_flag&(~ADC_T);

        ENCCMODE=0xff;
        TMA1CN=TMA1CN|0x80;
       }
      }

     }

   }
   else //'TP' calibrate mode
   {
    SHOWCAL2(); //show the 'CAL1 'MODE
    Delay(20000);//24*20ms
    while(!(PT_CAL&CAL_PIN));
    work_flag=work_flag|ADC_NO_CAL;//enable the 'no calibrate'flag
    error_show();//20221130
    HOLDMODE=calibrate_count;//0x4;//
    work_flag=work_flag|cal_ok;
    
//--initial the RF ---
      RS_initial();
      RF_Positive();
      work_flag=(~adc_int_flag)&work_flag; //clear flag;
      INTE0=INTE0|0x20;//enable adc interrupt
    while(work_flag&cal_ok)
    {
//--initial the RF ---

      while((work_flag&adc_ok_flag)==0)
      {
        Get_adc();//measure and get adc
      }
      INTE0=INTE0&0xdf; //diasble ADC interrupt
      INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
      work_flag=work_flag&(~adc_ok_flag);
    
      if(HOLDMODE>0)
      {
	   if(TP_ADC< CAL_ADC_BUF)
	    ADC_BUF=CAL_ADC_BUF- TP_ADC;
	   else
	    ADC_BUF=TP_ADC- CAL_ADC_BUF ;
	   if(ADC_BUF < 6)//2)
	   {

		CAL_ADC_BUF=(CAL_ADC_BUF+TP_ADC)>>1;
		HOLDMODE--;
		if(HOLDMODE==0)
		{
//;-------------------------------------------------------------------------------------------------------------------------------
//;ӋõhضT'ȻጢhضĿ˜ضȣ0?
//;---------------------------------------------------------------------------------------------------------------------------------
	     TS_TEMPERATURE();
	     TSV_VOLTAGE();
//;-----------------------------------------------------------------------------------------------------------
//; IF PT3.2=1 THEN: GAIN2 = 100H * (CC4H(VOL_37) - TVS_VALUE) / TP_ADX(VOL_37)
//;-------------------------------------------------------------------------------------------------------------
	     TP_ADC=CAL_ADC_BUF;
	     TP_GAIN=V2T_VALUE37; //0xaae; //0x0cc4;
	     TP_GAIN=TP_GAIN - TVS_VALUE;
	     TP_GAIN=((0x100*TP_GAIN)*10);////Ŵ10
	     TP_GAIN=(TP_GAIN+(TP_ADC>>2))/ TP_ADC;//TP_ADC>>2,for round up and round
	     //TP_GAIN=((0x100*TP_GAIN) +(TP_ADC>>2));//TP_ADC>>2,for round up and round down numbers
	     //TP_GAIN=(TP_GAIN*10)/ TP_ADC;//Ŵ10
	     TP_5A=0xa5;//0x5A;

	     work_flag=work_flag&(~cal_ok);
		}

	   }
	   else
	   {
		CAL_ADC_BUF=TP_ADC;
		HOLDMODE=calibrate_count;//0x7;//0x32;//
	   }
       AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
       AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
       work_flag=(~adc_int_flag)&work_flag; //clear flag;
       INTF0=INTF0& 0xdf; //clear ADCIF
       INTE0=INTE0|0x20;//enable adc interrupt
      }

    }
    work_flag=work_flag|cal_ok;
    work_flag=work_flag&(~ADC_T);
//--initial the RF ---
    RS_initial();
    RF_Positive();
    work_flag=(~adc_int_flag)&work_flag; //clear flag;
    INTE0=INTE0|0x20;//enable adc interrupt
    while(work_flag&cal_ok)
    {
     Get_adc();//measure and get adc
     if(work_flag&adc_ok_flag)
     {
      INTE0=INTE0&0xdf; //diasble ADC interrupt
      INTF0=INTF0&0xdf; //CLEAR ADC interrupt FLAG
      work_flag=work_flag&(~adc_ok_flag);
      if(work_flag&ADC_T)//
      { //show the 'TP' ADC CODE
        LED_Display_show(TP_ADC);
        //LED_Display_h(5, 0); //turn off 'piont'
        PT3INTE=PT3INTE| 0x40; //close the PT3.6 interrupt

      }
      else
      {
       //CACULATE THE Target temperature
         DEAL();
        //==show the target temperature
         LED_Display_show(TP_TEMPER);
         //LED_Display_h(5, 1); //light on 'piont'
         PT3INTE=PT3INTE| 0x40; //close the PT3.6 interrupt
      }
      AD1CN0=AD1CN0& 0xfe;//CMFR=0;DISABLE ADC CMFR;
      AD1CN0=AD1CN0| 0x01; //CMFR=1;ENABLE ADC CMFR;
      INTF0=INTF0& 0xdf; //clear ADCIF
      INTE0=INTE0| 0x20;//enable adc interrupt
     }
     if((PT3&KEY_POWER)==0)
     {
      Delay(3000);
      if((PT3&KEY_POWER)==0)
      {
      //==close LED show
       TMA1CN=TMA1CN&0x7f; //disable TMA1
       ENCCMODE=0x00;
       PT2=0;

       Delay(10000);
       while(!(PT3&KEY_POWER));
       Delay(5000);
       work_flag=work_flag&(~cal_ok);
       PT3INTE=PT3INTE& 0xBf; //close PT3.6 interrupt
       INTE0=INTE0&0x7f;//disable GIE;0x80;//enable GIE
         //SAVE THE CALIBRATE VALUE
       BIE_EEPMode(EEMODE_32bytes);  //Select EEPROM mode
       FSR0=&EERD4;
       CLEAR_EEPROM(4);//CLEAR THE EEPROM Buffer register,not BIE
       //CLEAR_EEPROM(0x4,4);//EERDCLR(32);  //Clear EERD0~63
       //--EERD4~EERD7 ---
        FSR0=&EERD4;
        DATA_BUF=TP_GAIN;
        POINC0=TP_5A;//EERD4
        POINC0=DATA_BUF&0xff;
        DATA_BUF=DATA_BUF>>8;
        POINC0=DATA_BUF&0xff;
        DATA_BUF=DATA_BUF>>8;
        POINC0=DATA_BUF&0xff;

        BIE_DataWrite();  //Write EERD to BIE

        work_flag=work_flag&(~ADC_NO_CAL);
        work_flag=work_flag&(~ADC_T);

        ENCCMODE=0xff;
        TMA1CN=TMA1CN|0x80;
       }

      }
     }

   }

  }

 }
//=====finish calibration mode=====
#ifdef UART_EN
 UARTInit();
#endif
 LED_Display_show(TP_TEMPER);
 INTE0=INTE0|0x80;//enable GIE
 sys_mode=1; //get into normal mode and  measure
 Time_out=0; //start time out counter
 while(sys_mode==1)
 {
   KEY_DEAL();
   if(work_flag&ADC_NO_CAL)//not calibrate
   {
    error_show();//SHOW 'C---'
   }
  // else
  // {
 //===get into low power mode =====
  if(KEYWORK_FLAG&key_power_flag) //idle or sleep mode
    {
      KEYWORK_FLAG=KEYWORK_FLAG&(!key_power_flag);
      Time_out=0; //start time out counter
    //==DISABLE ADC ===
      AD1CN0=AD1CN0&0x7f;//ENAD1=0;DISABLE ADC
      AD1CN5=0;
      INTE0=INTE0&0xdf; //disable the ADC INT
    //==DISABLE OP==
      LNAMP1=LNAMP1&0x7F;//ENPGA=0;
    //CLOSE ANALOG POWER
      CSFON_Enable();
      ENBOR2_Disable();
      PWRCN=0B00000000;//ENBGR=0,ENLDO=0;
    //==DISABLE LED==
      ENCCMODE=0x0;
      PT2=0;
      TMA1CN=TMA1CN&0x7f; //close TMA
      INTE0=INTE0&0x9f;//disable TMA &ADC interrupt
    //===close R/G/YELOOW LED==
      PT1=PT1|0x06;//PT1.2/PT1.2=1;
     #ifdef IC_BODY
      PT3=PT3|0x02;//PT3.1=1;
     #endif
    //==enable PT3.7 interrupt===
      Delay(5000);
      while(!(PT3&0x80));
      Delay(5000);
      PT3INT=PT3INT&0x7f;//fall edge trigger
      PT3INTF=PT3INTF&0x7f;//clear PT3.7 interrupt flag
      INTE0=INTE0&0x7f; //disable GIE
      PT3INTE=PT3INTE|0x80;//enable pt3.7 interrupt
      PT3INTF=PT3INTF&0x7f;//clear PT3.7 interrupt flag
      INTE0=INTE0|0x80;    //ENABLE GIE
    //==SET CLOCK==
      CLK_OSCSelect(OSCS_LPO);
      CLK_HAODisable();
      __asm__("nop");
      Sleep();                     //Sleep mode
      __asm__("nop");

      OSCCN2=OSCCN2|0x01;//0B00000101;//HAOM=10=8MHZ,ENHAO=1;
      __asm__("nop");
      __asm__("nop");
      PT3INTF=PT3INTF&0x7f;//clear PT3.7 interrupt flag
      PT3INTE=PT3INTE&0x7f;//Disable pt3.7 interrupt
      while(!(PT3&0x80)); //wait for PT3.7 =1
      Delay(50);


      CLK_OSCSelect(OSCS_HAO);
      sys_mode=0;
    }
//===IR temperature measure ======
  
    else if(KEYWORK_FLAG&key_scan_flag)
     {
       KEYWORK_FLAG=KEYWORK_FLAG&(!key_scan_flag);
       ENCCMODE=0xff;
       TMA1CN=TMA1CN|0x80; //enable TMA1
       #ifdef IC_BODY
        PT3=PT3|0x02;//pt3.1=0 red led on
       #endif
       PT1=PT1|0x02;//pt1.1=1 green led off
       PT1=PT1&0xfB;//pt1.2=0 yellow led on
       error_show();//20221130
//--initial the RF ---
       RS_initial();
       RF_Positive();
       work_flag=(~adc_int_flag)&work_flag; //clear flag;
       INTF0=INTF0& 0xdf;//clear adcif
       INTE0=INTE0|0x20;//enable adc interrupt
       Time_out=0; //start time out counter
       //error_show();
       while((work_flag&adc_ok_flag)==0)
       {
        Get_adc();//measure and get adc
       }

      if(work_flag&adc_ok_flag)
      {
        work_flag=work_flag&(~adc_ok_flag);

        DEAL(); //CACULATE The Target temperature
 
      if(work_flag&temper_high) //temperature high than the V2T table
      {
       TMA1CN=TMA1CN&0x7f; //disable TMA1
       ENCCMODE=0x00;
       PT2=0;
       Buzzer_ON();//BZ ON
       Delay(7000);
       Buzzer_OFF();//BZ OFF
       TMA1CN=TMA1CN|0x80; //enable TMA1
       ENCCMODE=0xFF;
       __asm__("nop");
       
        error_show();//SHOW 'C---'
     
        PT1=PT1|0x04;//pt1.2=1 yellow led off
        #ifdef IC_BODY
         PT3=PT3&0xfd;//pt3.1=0 red led on
        #endif
      }
      else
      {
       
        if(TP_TEMPER>high_temper)//temperature >37.5
        {
          //pt3.1 red led on
          PT1=PT1|0x04;//pt1.2=1 yellow led off
          #ifdef IC_BODY
           PT3=PT3&0xfd;//pt3.1=0 red led on
          #endif
        }
        else if(TP_TEMPER>low_temper)//temperature>32.00
        {
          PT1=PT1|0x04;//pt1.2=1 yellow led off

          PT1=PT1&0xfd;//pt1.1=0 green led on
        }
       TMA1CN=TMA1CN&0x7f; //disable TMA1
       ENCCMODE=0x00;
       PT2=0;
       Buzzer_ON();//BZ ON
       Delay(7000);
       Buzzer_OFF();//BZ OFF
       TMA1CN=TMA1CN|0x80; //enable TMA1
       ENCCMODE=0xFF;
       __asm__("nop");
       
   #ifdef LED_SHOW
        //LED_Display_show(TP_ADC);
        //LED_Display_show(RS_ADC);
        LED_Display_show(TP_TEMPER);
        //LED_Display_show(TS_TEMPER);
   #endif
   
   #ifdef UART_EN
       UART_ADC();
   #endif
       }
      
     
       Time_out=0; //start time out counter
      }

     }

  //}
  //== time out ++,when TMA1 interrupt once time ==
  if(Time_out>10000) //check time out counter=30s
  {

    AD1CN2=0B00000000; //SELVIN=0=VDDA/2
    LNAMP1=0B00000000;//ENPGA=0,
    LNAMP0=0B00000000;//
    TMA1CN=TMA1CN&0x7f; //disable TMA1
    ENCCMODE=0x00;
    //TRISC2=0xff;
    PT2=0;
    PT1=PT1|0x04;//pt1.2=1 yellow led off
    PT1=PT1|0x02;//pt1.1=1 greed led off
    PT3=PT3|0x02;//pt3.1=1
    Time_out=0;
  }
 }


}

/*----------------------------------------------------------------------------*/
/* Interrupt Service Routines                                                 */
/*----------------------------------------------------------------------------*/
void ISR(void) __interrupt
{
#ifdef LED_SHOW
    //TMA Event
  //A21023 V01 version
	unsigned char flag;
	flag=INTF0 & 0x40 ;
	if(flag == 0x40)
	{
	  Time_out++; //timer follow over
		INTF0 &= 0xBF;
		TMA1R=0;
		LEDScan=LEDScan>>1;
		if(LEDScan==0)
		{LEDScan=0x80;}

		switch(LEDScan)
		{
			case 0x01:
			{
				PT2= 0;
				TRISC2=LED[0] | 0x01;
				PT2=~(LED[0] & 0xFE);
				break;
			}
			case 0x02:
			{
				PT2= 0;
				TRISC2=LED[1] | 0x02;
				PT2=~(LED[1]& 0xFD);
				break;
			}
			case 0x04:
			{
				PT2= 0;
				TRISC2=LED[2] | 0x04;
				PT2=~(LED[2] & 0xFB);
				break;
			}
			case 0x08:
			{
				PT2= 0;
				TRISC2=LED[3] | 0x08;
				PT2=~(LED[3]& 0xF7);
				break;
			}
			case 0x10:
			{
				PT2= 0;
				TRISC2=LED[4] | 0x10;
				PT2=~(LED[4]& 0xEF);
				break;
			}
			case 0x20:
			{
				PT2= 0;
				TRISC2=LED[5] | 0x20;
				PT2=~(LED[5]& 0xDF);
				break;
			}
			case 0x40:
			{
				PT2= 0;
				TRISC2=LED[6] | 0x40;
				PT2=~(LED[6]& 0xBF);
				break;
			}
			case 0x80:
			{
				PT2= 0;
				TRISC2=LED[7] | 0x80;
				PT2=~(LED[7]& 0x7F);
				break;
			}
		}
	}
#endif
//==adc interrupt ==
 if(((INTE0&ADIE)==ADIE)&&((INTF0&ADIF)==ADIF))  //CHECK ADC FLAG
 {
   ADC_TEMP=ADCR; //SAVE ADC DATA
   INTF0=INTF0&0xdf;//clear ADC FLAG;
  // if(drop_out==0) //give up ADC data
   	work_flag=(adc_int_flag)|work_flag;//ENABLE ADC
  // else
  //  drop_out=drop_out-1;
  flash_count++; //LED flash show control

 }
 if((PT3INTE&0x40)&&(PT3INTF&0x40))
 {
   PT3INTF=PT3INTF& 0xBF; //clear PT3.6 interrupt flag
   PT3INTE=PT3INTE& 0xBF; //close the PT3.6 interrupt
   work_flag=work_flag^ADC_T; //SET show 'ADC CODE' AND 'Temperature'

 }
 if((PT3INTE&0x80)&&(PT3INTF&0x80))
 {
   PT3INTF=PT3INTF& 0x7F; //clear PT3.7 interrupt flag

 }
}

//----------------------------------------------------------------------------
// EEPROM Data Clear Function                                                 
// funct: clear EERPOM Buffer REGISTOR ,but no cleat the BIE
//
//----------------------------------------------------------------------------
void EERDCLR(unsigned char num)
{
  unsigned char eepcount;

  FSR0= &EERD0;
  for(eepcount=0;eepcount<num;eepcount++)
  {
    POINC0=0;
  }

}
//================================================
//name: CLEAR_EEPROM 
//funct: clear EERPOM Buffer REGISTOR ,but no cleat the BIE
//
//================================================
void CLEAR_EEPROM(unsigned char num)
{
  unsigned char eepcount;

 // FSR0=&EERD0;
  for(eepcount=0;eepcount<num;eepcount++)
  {
    POINC0=0;
  }
  
}
//-----------------------------------------------------
//name:SYS_Parameter_Read(void)
//FUNCT:READ The the calibration and other parameter From BIE
//-----------------------------------------------------
void SYS_Parameter_Read(void)
{
 work_flag=work_flag|ADC_NO_CAL;//
 BIE_EEPMode(EEMODE_32bytes);  //Select EEPROM mode
 EERDCLR(32);  //Clear EERD0~63

 //BIE_DataReload();
 BIE_EEPReload();
 __asm__ ("NOP");  //Wait a NOP instruction time after write EERC2 register

 TS_GAIN=0;
 TP_GAIN=0;

 FSR0= &EERD7;
 //READ 'TP_GAIN'
 TP_GAIN=PODEC0;
 TP_GAIN=(TP_GAIN<<8)|PODEC0;
 TP_GAIN=(TP_GAIN<<8)|PODEC0;
 TP_5A=PODEC0; //READ 'TP_5A'
 //READ 'TS_GAIN'
 TS_GAIN=PODEC0;
 TS_GAIN=(TS_GAIN<<8)|PODEC0;
 TS_GAIN=(TS_GAIN<<8)|PODEC0;
 TS_5A=PODEC0; //READ 'TS_5A'
 if(TS_5A==0x5a)
 {
  if(TP_5A==0xa5)
  {
   work_flag=work_flag&(~ADC_NO_CAL); //
  }
 }

}

//------------------------------------------------------
//when OSC CPU_CK=2MHZ, Delay(1000)=24~28mS
//----------------------------------------------------
void Delay(unsigned int num)
{
  while(num--);
}
//********************************************************************************
//**** key scan *******
//*******************************************************************************
void KEY_DEAL(void)
{
	unsigned char temp;
	temp=PT3&0xc0;//PT3.6/3.7//PT1&0x30;//READ PT1.4/PT1.5
	if(temp==0xC0)
	{
		keystate=(keystate<<1)|0x01;
		if(keystate==0xffff)		//ִ
		{
			key_flag=0x0;
			return;
		}
	}
	else
	{
		keystate=keystate<<1;
		if(key_flag==0x00)
		{
			if(keystate==0x8000)
			{
				key_flag=0x01;
				switch(temp)
				{
				 case 0x80://PT3.6//0x20: //PT1.4
				    {
				      KEYWORK_FLAG=KEYWORK_FLAG|key_scan_flag;
				      break;
				    }
				 case 0X40://PT3.7//0x10: //PT1.5
				    {
				     KEYWORK_FLAG=KEYWORK_FLAG|key_power_flag;
				     break;
				    }
				 default:
				    break;

				}
			}
		}

	}//*/
}
//------------------------------------------------------
/*----------------------------------------------------------------------------*/
/* UART Init Function                                                          */
/*----------------------------------------------------------------------------*/
void UARTInit(void)
{
  //GPIO Init
  TRISC1=TRISC1|0x08;
  GPIO_GTXSet(GTX_PT13);  //Rx PT14

  //BRGR[15:0]=((CPUCK/Baudrate)/4)-1
#ifdef HAO_2MHZ
  //((1843000/9600)/4)-1 =47, HAO=1.843M, baudrate=9600
  UART0_Open(46 ,8 ,PARITY_None);
#endif
#ifdef HAO_4MHZ
  //((4147000/9600)/4)-1 =107, HAO=4.147M, baudrate=9600
  UART0_Open(107 ,8 ,PARITY_None);
#endif
#ifdef HAO_8MHZ
  //((8755000/9600)/4)-1 =227, HAO=8.755M, baudrate=9600
  UART0_Open(227 ,8 ,PARITY_None);
#endif
#ifdef HAO_16MHZ
  //((17510000/9600)/4)-1 =455, HAO=17.51M, baudrate=9600
  UART0_Open(455 ,8 ,PARITY_None);
#endif

#ifdef UART_ABD
  UART0_Open(0 ,8 ,PARITY_None);
  UART0_WUEDisable();                   // Wake-up disable
  UART0_ABDEnable();                    //Enable Auto Baudrate
  while((BA0CN & 0x01) == 1 );      //Wait for master send 055H
  UART0_INT_RCClearFlag();          //Clear RC interrupt flag

#endif
 // TX0R=0xaa;
  //TXIE_Enable();
 // RCIE_Enable();
}
//==============================================
void UART_ADC(void)
{
  unsigned char i=4;
  unsigned char j=0;

    //TS ADC
    CAL_ADC_BUF=RS_ADC;
    UartTxBuffer[4]=CAL_ADC_BUF&0xff;
    CAL_ADC_BUF=CAL_ADC_BUF>>8;
    UartTxBuffer[5]=CAL_ADC_BUF&0xff;
    CAL_ADC_BUF=CAL_ADC_BUF>>8;
    UartTxBuffer[6]=CAL_ADC_BUF&0xff;
    //TP ADC
    CAL_ADC_BUF=TP_ADC;
    UartTxBuffer[7]=CAL_ADC_BUF&0xff;
    CAL_ADC_BUF=CAL_ADC_BUF>>8;
    UartTxBuffer[8]=CAL_ADC_BUF&0xff;
    CAL_ADC_BUF=CAL_ADC_BUF>>8;
    UartTxBuffer[9]=CAL_ADC_BUF&0xff;
    //CACULATE CHECKSUM
    UartTxBuffer[10]=UartTxBuffer[3]+UartTxBuffer[4]+UartTxBuffer[5]+
    UartTxBuffer[6]+UartTxBuffer[7]+UartTxBuffer[8]+UartTxBuffer[9];
    //==transfor data==
    for(j=0;j<Uart_TX_BufferSize;j++)
    {
      INTE0=INTE0&0x7f;//disable GIE

      TX0R=UartTxBuffer[j];
      while(!(INTF1&0x20));//check TXIF=1;
      while(!(UR0STA&0x02));//cheak TRMT=1;

      INTE0=INTE0|0x80;//enable GIE
    }



}
